!define APPNAME "FreeNBTV"
!define DESCRIPTION "Narrowband Television Generator"

!define VERSIONMAJOR 0
!define VERSIONMINOR 3
!define VERSIONBUILD 1

!define INSTALLSIZE 36000

RequestExecutionLevel admin

InstallDir "$PROGRAMFILES\FreeNBTV\"
LicenseData "GPL.txt"
Name "FreeNBTV"
outFile "freeNBTV-alpha3-install.exe"

Page license
Page directory
Page instfiles

function .onInit
	setShellVarContext all
functionEnd

section "install"
	setOutPath $INSTDIR
	file /r "bin"
	file /r "lib"
	file /r "share"
	file "GPL.txt"
	exec "$INSTDIR\bin\bin\gdk-pixbuf-query-loaders.exe > $INSTDIR\lib\gdk-pixbuf-2.0\2.10.0\loaders.cache"
	
	writeUninstaller "$INSTDIR\uninstall.exe"
	
	createDirectory "$SMPROGRAMS\FreeNBTV"
	createShortCut "$SMPROGRAMS\FreeNBTV\FreeNBTV Gen.lnk" "$INSTDIR\bin\freenbtvgen.exe"
	
	# Registry information for add/remove programs
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FreeNBTV" "DisplayName" "FreeNBTV - ${APPNAME} - ${DESCRIPTION}"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FreeNBTV" "UninstallString" "$\"$INSTDIR\uninstall.exe$\""
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FreeNBTV" "QuietUninstallString" "$\"$INSTDIR\uninstall.exe$\" /S"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FreeNBTV" "InstallLocation" "$\"$INSTDIR$\""
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FreeNBTV" "DisplayVersion" "$\"${VERSIONMAJOR}.${VERSIONMINOR}.${VERSIONBUILD}$\""
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FreeNBTV" "VersionMajor" ${VERSIONMAJOR}
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FreeNBTV" "VersionMinor" ${VERSIONMINOR}
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FreeNBTV" "NoModify" 1
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FreeNBTV" "NoRepair" 1
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FreeNBTV" "EstimatedSize" ${INSTALLSIZE}
sectionEnd

 
function un.onInit
	SetShellVarContext all
	MessageBox MB_OKCANCEL "Remove ${APPNAME}?" IDOK next
		Abort
	next:
functionEnd
 
section "uninstall"
 
	delete "$SMPROGRAMS\FreeNBTV\FreeNBTV Gen.lnk"
	rmDir "$SMPROGRAMS\FreeNBTV"
 
	delete "$INSTDIR\freenbtvgen.bat"
	delete "$INSTDIR\GPL.txt"
	
	rmDir /r "$INSTDIR\bin"
	rmDir /r "$INSTDIR\share"
	rmDir /r "$INSTDIR\lib"
	
	delete "$INSTDIR\uninstall.exe"
	
	# Try to remove the install directory - this will only happen if it is empty
	rmDir $INSTDIR
 
	# Remove uninstaller information from the registry
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FreeNBTV ${APPNAME}"
sectionEnd